<?php
class c_rss_generator {
  // obsah jednotlivch kanl
  var $chanel = array();
  // pouit kodovn
  var $rss_encoding = 'iso-8859-2';
  // verze RSS
  var $rss_version = '0.91';
  
  // pid nov kanl do RSS
  function add_chanel($name, $param) {
    $this->chanel[$name] = $param;
    $this->chanel[$name]['.item'] = array();
  }
  // pid novou poloku do kanlu
  function add_item($chanel_name, $param) {
    $this->chanel[$chanel_name]['.item'][] = $param;
  }
  // pid novou poloku do kanlu
  function create_rss() {
    // vytvo a nastav instanci tdy c_xml_generator
    $xg = new c_xml_generator();
    $xg->xml_encoding = $this->rss_encoding;
    // vytvo nejvy xml element rss a nasta verzi rss
    $x_rss = $xg->add_node(0, 'rss',
      array('version'=>$this->rss_version)
    );
    // postupn prochz pole $chanel
    foreach($this->chanel as $chanel) {
      // vlo element chanel
      $x_chanel = $xg->add_node($x_rss, 'chanel');
      // prochz jednotliv parametry kanlu
      foreach($chanel as $param_name => $param_value) {
        // pokud je parametr 'image' nebo 'textInput' projde a vlo jeho parametry
        if (($param_name == 'image') || ($param_name == 'textInput')) {
          $x_image = $xg->add_node($x_chanel, $param_name);
          foreach($param_value as $image_param_name => $image_param_value) {
            $xg->add_node_cdata($x_image, $image_param_name, $image_param_value);
          };
        // pokud je parametr 'item' - jednotliv0 poloky kanlu, projde a vlo je
        } elseif ($param_name == '.item') {
          foreach($chanel['.item'] as $item) {
            // pro kadou poloku vyvto element item
            $x_item = $xg->add_node($x_chanel, 'item');
            // projde a vlo jednotliv parametry
            foreach($item as $item_param_name => $item_param_value) {
              // pokud je parametr 'image' nebo 'textInput' projde a vlo jeho parametry
              if (($item_param_name == 'image') || ($item_param_name == 'textInput')) {
                $x_image = $xg->add_node($x_item, $item_param_name);
                foreach($item_param_value as $image_param_name => $image_param_value) {
                  $xg->add_node_cdata($x_image, $image_param_name, $image_param_value);
                };
              // pokud jde o jin parametr vlo jeho hodnotu
              } else {
                $xg->add_node_cdata($x_item, $item_param_name ,$item_param_value);
              };
            };
          };
        // pokud jde o jin parametr vlo jeho hodnotu
        } else {
          $xg->add_node_cdata($x_chanel, $param_name ,$param_value);
        };
      };
    };
    // nakonec vygeneruje a vrt vsledn XML
    return($xg->create_xml());
  }
};

?>
